var YOGOAAT = YOGOAAT || {};

YOGOAAT.ImageManagerHelperFiles = function() {
	this.loadImage = function(key, index){
		return document.getElementById(key);
	}

	this.imageIndex = function(key, tick) {
		return 0;
	}
}

YOGOAAT.ImageManagerHelperSpriteSheet = function() {

	this.httpRequest = new XMLHttpRequest();

	this.jsonLoaded = false;
	this.sheetLoaded = false;

	this.httpRequest.open("GET", "medias/sprites.json", true);
	this.httpRequest.onload = function(e){
		log("Sprite JSON ready");
		this.jsonLoaded = true;

		this.data = JSON.parse(this.httpRequest.responseText);

	}.bind(this);

	this.httpRequest.send();

	this.sheet = new Image();
	this.sheet.src = "medias/sprites.png";

	this.sheet.onload = function(e){
		log("Sprite sheet ready");
		this.sheetLoaded = true;
	}.bind(this);
	

	
	this.loadImage = function(key, index){
		log("key " + key);
		log("index " + index);
		var canvas = document.createElement('canvas');
		
		var x = this.data[key][index]['x'];
		var y = this.data[key][index]['y'];
		var w = this.data[key][index]['width'];
		var h = this.data[key][index]['height'];

		var context = canvas.getContext("2d");
		
		canvas.width  = w;
		canvas.height = h;

		context.drawImage(this.sheet, x, y, w, h, 0, 0, w, h);
		return canvas;
	}

	this.imageIndex = function(key, tick) {
		
		if (this.data[key] == undefined) {
			log("Image not found");
			return null;
		}

		var index = 0;
		var count = this.data[key].length;
		index = tick % count;

		log("tick : " + tick);
		log("load image for index : " + index + " on " + count);

		if (this.data[key][index] == undefined) {
			log("image not found for index : " + index);
			return null;
		}

		//todo cache
		return index;

	}
}

YOGOAAT.ImageManager = function() {

	this.cache = {};
	this.helper = new YOGOAAT.ImageManagerHelperSpriteSheet();
	this.tick = 0;

	this.getImage = function(category, type, variant){

		var key = category;
		if (type != undefined) 		key += "-" + type;
		if (variant != undefined) 	key += "-" + variant;

		var index = this.helper.imageIndex(key, this.tick);
		var completeKey = key + "-" + index;

		log("image manager : getImage : " + completeKey);

		if (this.cache[completeKey] == undefined) {
			this.cache[completeKey] = this.helper.loadImage(key, index);
			log("keep in cache");
		} else {
			log("already cached");
		}

		return this.cache[completeKey];
	}

}
