var YOGOAAT = YOGOAAT || {};

YOGOAAT.Keyboard = function() {
  this.pressed = {};
  this.currentKeyDown = -1,

  this.LEFT = 37;
  this.UP = 38;
  this.RIGHT = 39;
  this.DOWN = 40;
  this.SPACE = 32;

  this.onKeyDownBind;
  this.onKeyUpBind;

  this.isArrow = function(keyCode) {
      if (keyCode >= this.LEFT && keyCode <= this.DOWN) {
        return true;
      }

      return false;
  }

  this.isDown = function(keyCode) {
    return this.pressed[keyCode];
  };
  
  this.isSpecial = function(event) {
     if (event.altKey || event.ctrlKey || event.shiftKey || event.keyCode ==91) {
      return true;
     }

  }

  this.clear = function(){
    delete this.pressed;

    this.pressed = {};
    this.currentKeyDown = -1;
  }

  this.onKeyDown = function(event) {
    log("KeyDown : " + event.keyCode);

    this.pressed[event.keyCode] = true;
    this.currentKeyDown = event.keyCode;
    
    if (this.isArrow(event.keyCode)) {
      event.preventDefault();  
    }
    
    if (this.isSpecial(event)) {
      this.clear(); 
    }

  };
  
  this.onKeyUp = function(event) {
    log("KeyUp : " + event.keyCode);

    delete this.pressed[event.keyCode];
    this.currentKeyDown = -1;

    if (this.isArrow(event.keyCode)) {
      event.preventDefault();  
    }
    
    if (this.isSpecial(event)) {
      this.clear(); 
    }


  };

};

YOGOAAT.Keyboard.prototype.startListen = function () {

  this.stopListen();

  this.onKeyUpBind = this.onKeyUp.bind(this);
  this.onKeyDownBind = this.onKeyDown.bind(this);

  window.addEventListener('keyup', this.onKeyUpBind, false);
  window.addEventListener('keydown', this.onKeyDownBind, false);
};

YOGOAAT.Keyboard.prototype.stopListen = function (){
  window.removeEventListener('keyup', this.onKeyUpBind);
  window.removeEventListener('keydown', this.onKeyDownBind);
};


