var YOGOAAT = YOGOAAT || {};

YOGOAAT.Level = function() {
	
	this.index;

	//public
	this.mask;
	this.canvasMask;
	this.maskContext;
	
	this.layers = {
		bg: [], 
		fg: []
	};

	this.actors = [];
	this.actorsCouples = {};

	this.camera = YOGOAAT.Box.make();

	this.hero;
	this.dropZone;
	this.cameraPan = false;

	this.collected = [];
	this.onFinish;

	this.layerSorter = function(a, b){
		
		if (a.index < b.index) {
			return -1;
		}

		if (a.index > b.index) {
			return 1;
		}

		return 0;

	}


	this.build = function() {
		this.layers.bg.sort(this.layerSorter);
		this.layers.fg.sort(this.layerSorter);

		console.log(this.layers);

		this.canvasMask = document.createElement("canvas");
		//this.canvasMask = document.getElementById("mask");
		this.canvasMask.height 	= this.mask.height;
		this.canvasMask.width	= this.mask.width;

		this.maskContext = this.canvasMask.getContext("2d");
		this.maskContext.drawImage(this.mask, 0, 0);



		//common
		this.dropZone = new YOGOAAT.Actor();
		this.dropZone.name = "zone";
		this.dropZone.isTakeable=false;
		this.dropZone.boundingBox = YOGOAAT.Box.make2d(800, 200, 64, 64);
		
		this.hero = this.makeHero();

		this.actors.push( this.hero );
		this.actors.push( this.dropZone );

		switch(this.index) {
			case 0: 
				this.prepareLevel0();
				break;
			case 1: 
				this.prepareLevel1();
				break;
			case 2: 
				this.prepareLevel2();
				break;
			case 3: 
				this.prepareLevel3();
				break;
			case 4: 
				this.prepareLevel4();
				break;
		}
		
		this.dropZone.lastGoodBoundingBox = this.dropZone.boundingBox.clone();
		this.dropZone.hitBox = this.dropZone.boundingBox.clone();
		this.dropZone.hitBox.x = 0;
		this.dropZone.hitBox.y = 0;

		this.buildActorsCouple();
	}

	this.getBig = function(x){
		var item = new YOGOAAT.Actor();
		item.name = "big";
		item.boundingBox = YOGOAAT.Box.make2d(x ? x : 200,70, 32, 32);
		item.lastGoodBoundingBox = item.boundingBox.clone();
		item.hitBox = item.boundingBox.clone();
		item.hitBox.x = 0;
		item.hitBox.y = 0;
		item.bearerVelocityMultiplier.x = 0.5;
		item.bearerVelocityMultiplier.y = 0;
		item.bearerJumpQuantityMultiplier = 0.1;

		return item;
	}

	this.getLong = function(x){
		
		var item = new YOGOAAT.Actor();
		item.name = "long";
		item.boundingBox = YOGOAAT.Box.make2d(x ? x : 150,10, 64,18);
		item.lastGoodBoundingBox = item.boundingBox.clone();
		item.hitBox = item.boundingBox.clone();
		item.hitBox.x = 0;
		item.hitBox.y = 0;

		return item;
	}

	this.getShort = function(x){
		var item = new YOGOAAT.Actor();
		item.name = "short";
		item.boundingBox = YOGOAAT.Box.make2d(x ? x : 150,10, 32,6);
		item.lastGoodBoundingBox = item.boundingBox.clone();
		item.hitBox = item.boundingBox.clone();
		item.hitBox.x = 0;
		item.hitBox.y = 0;

		return item;
	}

	this.getSmall = function(x, y){ //antigrav
		var item = new YOGOAAT.Actor();
		item.name = "small";
		item.boundingBox = YOGOAAT.Box.make2d(x ? x : 150, y ? y :10, 12,12);
		item.lastGoodBoundingBox = item.boundingBox.clone();
		item.hitBox = item.boundingBox.clone();
		item.hitBox.x = 0;
		item.hitBox.y = 0;
		item.bearerVelocityMultiplier.x   = 1.9;
		item.bearerVelocityMultiplier.y   = 1;
		item.bearerJumpQuantityMultiplier = 5;

		return item;
	}

	this.prepareLevel0 = function(){
		this.actors.push( this.getBig(550) );
		
	}

	this.prepareLevel1 = function(){
		this.actors.push( this.getBig(250) );
		this.actors.push( this.getLong() );
	}

	this.prepareLevel2 = function(){
		this.actors.push( this.getSmall(800, 1700) );
		this.actors.push( this.getLong() );
		
		this.dropZone.boundingBox.x = 430;
		this.dropZone.boundingBox.y = 0;
	}

	this.prepareLevel3 = function(){
		this.actors.push( this.getBig(580) );
		this.actors.push( this.getBig(1050) );
		this.actors.push( this.getLong(500) );
		this.actors.push( this.getSmall(450) );
		this.actors.push( this.getShort(300) );
	}
	
	this.prepareLevel4 = function(){
		/*this.actors.push( this.getBig() );
		this.actors.push( this.getLong() );*/
	}



	this.buildActorsCouple = function () {
		this.actorsCouples = {};

		for (var i = 0; i < this.actors.length; i++) {
			var first = this.actors[i];
			
			for (var j = 0; j < this.actors.length; j++) {
				var second = this.actors[j];

				var couple1 = first.name + "/" + second.name;
				var couple2 = second.name + "/" + first.name;

				if (first == second || this.actorsCouples[couple1] != undefined || this.actorsCouples[couple2] != undefined) {
					continue;
				}

				this.actorsCouples[couple1] = {};
				this.actorsCouples[couple1].first = first;
				this.actorsCouples[couple1].second = second;

			};
			
		};

		console.log(this.actorsCouples);
	}

	this.makeHero = function(){
		var hero = new YOGOAAT.Actor();
		hero.handleDirections = true;
		hero.name = "hero";
		//x, y, w, h
		hero.boundingBox = YOGOAAT.Box.make2d(50, 100, 39, 64);
		hero.lastGoodBoundingBox = hero.boundingBox.clone();

		hero.hitBox 	 = YOGOAAT.Box.make2d(15, 32, 12, 28);
		hero.direction	 = YOGOAAT.Vector.make2d(1,0);
		hero.jumpQuantity = 100;

		return hero;
	}


	this.collideToWorld = function(actor) {

		var imageData = this.maskContext.getImageData(
			actor.boundingBox.x + actor.hitBox.x,
			actor.boundingBox.y + actor.hitBox.y,
			actor.hitBox.width,
			actor.hitBox.height
		);

		var foundGround = -1;

		for (var i = 0; i < imageData.data.length; i += 4) {
			var red 	= imageData.data[i+0];
			var green 	= imageData.data[i+1];
			var blue 	= imageData.data[i+2];
			var alpha 	= imageData.data[i+3];

			if (red == 0 && green == 0 && blue == 0) {
				foundGround = i/4;
				break;
			}
		}

		if (foundGround == -1) {
			return false;
		}

		//collision found, calculate last good pos 
		var pointInHitBox = {
			x: foundGround % imageData.width,
			y: Math.floor(foundGround / imageData.width)
		}

		var point = YOGOAAT.Vector.make2d(0, -1 * (actor.hitBox.height - pointInHitBox.y));

		log("COLLISION at " + foundGround);
		log(pointInHitBox);
		log(point);

		return point;

	};

	this.addCollected = function(item){
		var index = this.actors.indexOf(item);

		if (index == -1) {
			return;
		}

		this.actors.splice(index, 1);
		
		if(this.actors.length == 2) { //hero and zone only
			this.onFinish();
		}

		this.buildActorsCouple();
	}

};

