var YOGOAAT = YOGOAAT || {};

YOGOAAT.LevelLoader = function() {
	//public
	this.onLevelLoad;
	this.onLevelLoadError;

	this.currentLevel;

	//private
	var imageCount = 3;
	var loadedImageCount = 0;
	var errorImageCount = 0;

	this.load = function(levelIndex){

		this.currentLevel = new YOGOAAT.Level();
		this.currentLevel.index = levelIndex;
		loadedImageCount = 0;
		errorImageCount = 0;

		var path = "levels/level-" + levelIndex + "/";
		
		this.loadAllImages(path, 5, 5);
		
	};

	this.loadAllImages = function(path, nbBg, nbFg){
		imageCount = 1 + nbBg + nbFg;

		this.loadUrlImage(path + "level-mask.png", "mask", -1);
		
		for (var i = 0; i < nbBg; i++) {
			this.loadUrlImage(path + "level-bg-"+i+".png", "bg", i);
		};
		
		for (var i = 0; i < nbFg; i++) {
			this.loadUrlImage(path + "level-fg-"+i+".png", "fg", i);
		};

	}

	this.loadUrlImage = function(url, type, index){
		var image  = new Image();
		image.src  = url;
		image.type =  type;
		image.index = index;

		image.onload  = this.onLoadImage.bind(this);
		image.onerror = this.onErrorImage.bind(this);
	}

	this.onLoadImage = function(event) {
		loadedImageCount ++;

		if (event.target.type == "mask"){
			this.currentLevel.mask = event.target;
			this.triggerWhenDone();
			return;
		}

		var layer = {
			img: event.target, 
			index: event.target.index,
			type: event.target.type,
			src: event.target.src
		};

		this.currentLevel.layers[ event.target.type ].push( layer );
		this.triggerWhenDone();
	}

	this.onErrorImage = function(event) {
		errorImageCount ++;
		this.triggerWhenDone();
	}

	this.triggerWhenDone = function(){
		
		if (loadedImageCount + errorImageCount == imageCount) {
		
			this.currentLevel.build();
			this.onLevelLoad(this.currentLevel);

		}
	};

};