var YOGOAAT = YOGOAAT || {};

YOGOAAT.SoundManager = function() {

	this.context;
	this.buffers = {};

	this.init = function() {

		window.AudioContext = window.AudioContext || window.webkitAudioContext;
		this.context = new AudioContext();

		this.buffers = {
			"start" : { },
			"take"  : { },
			"drop"  : { },
			"collect" : { },
			"win"   : { },
			"jump"   : { }
		};

		for(var key in this.buffers){
			var url = "medias/" + key + ".mp3";
			this.buffers[key].loader = new YOGOAAT.SoundLoader(this.context, key, url);
			this.buffers[key].loader.onBufferReady = this.soundReady.bind(this);
			this.buffers[key].loader.load();
		}


	};

	this.soundReady = function(key, buffer){
		this.buffers[key].buffer = buffer;
	}


	this.play = function(key) {

		if (! this.buffers[key]) {
			return;
		}

		var buffer = this.buffers[key].buffer;

		if (!buffer) {
			return;
		}

		if (this.buffers[key].playing) {
			return;
		}

		var source = this.context.createBufferSource(); // creates a sound source
		source.buffer = buffer;                    // tell the source which sound to play

		
		var gainNode = this.context.createGain();

		source.connect(gainNode);
		gainNode.connect(this.context.destination);
		gainNode.gain.value = 0.5;
		source.start(0); 
		


		source.onended = function(){
			this.buffers[key].playing=false;
		}.bind(this);

		this.buffers[key].playing=true;
	}

};



YOGOAAT.SoundLoader = function(context, key, url){
	this.context = context;
	this.url = url;
	this.key = key;
	this.request;

	this.onBufferReady;

	this.load = function() {
		this.request = new XMLHttpRequest();
  		this.request.open('GET', this.url, true);
  		this.request.responseType = 'arraybuffer';
  		this.request.onload = this.dataLoad.bind(this);
  		this.request.send();
	}

	this.dataLoad = function(event) {
		this.context.decodeAudioData(this.request.response, this.decodeSuccess.bind(this), this.decodeError.bind(this));
	}

	this.decodeSuccess = function(buffer) {
		this.onBufferReady(this.key, buffer);
	}

	this.decodeError = function(buffer) {
		console.log("ERROR");
	}
}



